/*
   Copyright 2009 Andrea Pagnani and Alfredo Braunstein

   This file is part of DILPERC (DILuted discrete PERCeptron analysis tool).

   DILPERC is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License Version 2 
   as published by the Free Software Foundation 

   DILPERC is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with DILPERC; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef BP_H
#define BP_H

#include <omp.h>
#include "random.h"


extern int Q,N,M;
extern double **X;
extern double **P;
extern double *Y;
extern double err;


/* parameters */
extern int nmax;
extern int deltan;
extern double *Hext;
extern double hdil;
extern double beta;
extern double deltahdil;
extern int nonlinear;

/* bp functions*/
void init();
void free_memory();
double iterate();
void read_matrix(char *filename);
void print_marginals();
void compute_marginals();
double entropy();
int converge(int T);
int paracooling(int T, double deltahdil); 
int decimate(int T, int deltan, int nmax);


#endif
